import { Choice, Map, Parallel, Pass, State, StateMachine, Task, Wait } from 'asl-types';
import * as Serverless from 'serverless';
import * as ServerlessPlugin from 'serverless/classes/Plugin';
import { Logging } from 'serverless/classes/Plugin';
import { AsyncCallback, Callback, ChoiceConditional, ContextObject, Event, Maybe, Options, StateMachineBase, StateValueReturn } from './types';
export declare class StepFunctionsOfflinePlugin implements ServerlessPlugin {
    private location;
    private readonly functions;
    private readonly detailedLog;
    eventFile: Options['eventFile'] | Options['ef'];
    event: Options['event'] | Options['e'];
    loadedEventFile: Maybe<Event>;
    variables?: {
        [key: string]: string;
    };
    private environmentVariables;
    private cliLog;
    stateDefinition?: StateMachine;
    private mapResults;
    private eventForParallelExecution?;
    private currentStateName;
    private currentState;
    private contexts;
    private states;
    private parallelBranch;
    private eventParallelResult;
    shouldTerminate: boolean;
    serverless: Serverless;
    options: Options;
    commands: ServerlessPlugin.Commands;
    hooks: ServerlessPlugin['hooks'];
    cli: Logging;
    stateMachine: Options['stateMachine'];
    lambdaEndpoint: Options['lambdaEndpoint'];
    environment: string;
    constructor(serverless: Serverless, options: Options, cli: Logging);
    exit(): void;
    start(): void;
    _getLocation(): void;
    _checkVersion(): void;
    _checkVariableInYML(): void;
    isInstalledPluginSLSStepFunctions(): void;
    loadEventFile(): Promise<void>;
    loadEnvVariables(): void;
    findState(): Promise<void>;
    private parseYaml;
    private serverlessFileExists;
    getRawConfig(): Promise<Serverless['service']>;
    parseConfig(): Promise<void>;
    getStateMachine(stateMachineName: string): StateMachineBase;
    _loadStates(states: StateMachine['States'] | string): Promise<StateMachine['States']>;
    buildStepWorkFlow(): Promise<ReturnType<StepFunctionsOfflinePlugin['process']>>;
    buildSubStepWorkFlow(stateDefinition: StateMachine, event: Event): Promise<ReturnType<StepFunctionsOfflinePlugin['process']>>;
    process(state: State, stateName: string, event: Event): void | Promise<void | Callback> | Callback;
    _findStep(currentState: State, currentStateName: string): StateValueReturn;
    _run(func: Callback | Promise<void | AsyncCallback>, event: Event, name: string): void | Promise<void | Callback> | Callback;
    _handleMap(currentState: Map, stateName: string): StateValueReturn;
    _invokeLambdaFn(func: Serverless.FunctionDefinitionHandler | Serverless.FunctionDefinitionImage): (event: any) => Promise<AsyncCallback>;
    _handleTask(currentState: Task, stateName: string): StateValueReturn;
    _handleParallel(currentState: Parallel): StateValueReturn;
    _handleChoice(currentState: Choice): ChoiceConditional;
    _handleWait(currentState: Wait, stateName: string): StateValueReturn;
    _handlePass(currentState: Pass): StateValueReturn;
    _states(currentState: State, currentStateName: string): StateValueReturn;
    _passStateFields(currentState: Pass, event: Event): Event;
    _runChoice(data: ChoiceConditional, result: Event): void | Promise<void | Callback> | Callback;
    _waitState(event: Event, currentState: State, currentStateName: string): number;
    addContextObject(states: StateMachine['States'], name: string, event: Event): void;
    createContextObject(states: StateMachine['States'], name: string, originalEvent: Event): ContextObject;
    executionLog(log: string): void;
}
