declare type MapFn<I, O> = (item: I, index: number, array: I[]) => Promise<O>;
interface WorkerResult<O> {
    status: 'rejected' | 'fulfilled';
    reason?: Error;
    value?: O;
}
export declare type Logger = (string: any) => void;
export declare function withWorkers<I, O>(arr: I[], mapFn: MapFn<I, O>, limit?: number, logger?: Logger): Promise<WorkerResult<O>[]>;
export {};
